org.codehaus.groovy.ast.builder

## Class AstBuilderTransformation

- java.lang.Object
- - org.codehaus.groovy.ast.builder.AstBuilderTransformation

All Implemented Interfaces:
  ASTTransformation

    public class AstBuilderTransformation
    extends java.lang.Object
    implements ASTTransformation

Transformation to capture ASTBuilder from code statements.

The AstBuilder "from code" approach is used with a single Closure parameter. This transformation converts the ClosureExpression back into source code and rewrites the AST so that the "from string" builder is invoked on the source. In order for this to work, the closure source must be given a goto label. It is the "from string" approach's responsibility to remove the BlockStatement created by the label.

Author:
  Hamlet D'Arcy

### Constructor Summary

Constructors
Constructor and Description
`AstBuilderTransformation()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `visit(ASTNode[] nodes, SourceUnit sourceUnit)` The method is invoked when an AST Transformation is active.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AstBuilderTransformation

    public AstBuilderTransformation()

### Method Detail

#### visit

    public void visit(ASTNode[] nodes,
                      SourceUnit sourceUnit)

Description copied from interface: `ASTTransformation`
The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.

Specified by:
  `visit` in interface `ASTTransformation`
Parameters:
  `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
  `sourceUnit` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.